/*----- PROTECTED REGION ID(TopupSB.h) ENABLED START -----*/
//=============================================================================
//
// file :        TopupSB.h
//
// description : Include for the TopupSB class.
//
// project :     TopupSB.
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TOPUPSB_H
#define TOPUPSB_H


#include <tango.h>
#include <math.h>
#include <sys/time.h>

/*----- PROTECTED REGION END -----*/


#define TOPUPSB_STAT_SIZE			22	/*  status size */
#define TOPUPSB_FILLPATH_ERR		0  	/* error reading fillpath */
#define TOPUPSB_GUNTIMING_ERR		1        /* error reading guntiming */
#define TOPUPSB_TOPUP_ERR                    2 	/* error reading topup */
#define TOPUPSB_THREAD_STANDBY        	3	/* Inside Loop but not correcting */
#define TOPUPSB_THREAD_CORRECTION            4	/* applying correction */
#define TOPUPSB_THREAD_SLEEP        	5	/* sleeping thread */
#define TOPUPSB_THREAD_ON        		6	/* Start Feedback */
#define TOPUPSB_THREAD_ERR        		7	/* General error inside the loop */
#define TOPUPSB_THREAD_ERR_THRESHOLD	8	/* Correction request over threshold */
#define TOPUPSB_THREAD_MSG        		9	/* Message to operators */
#define TOPUPSB_DCCT_ERR			10  	/* error reading dcct */
#define TOPUPSB_DCCT_CURR			11  	/* to low current in SR */
#define TOPUPSB_GRID_ERR			12  	/* error setting Grid limit */
#define TOPUPSB_SB_SET                       13       /* SB setting missing */
#define TOPUPSB_WAIT                       14       /* Vicini all'iniezione in MB normlae */
#define TOPUPSB_WAIT_MAX                       15       /* Molto lontani dall'iniezione, attesa */
#define TOPUPSB_WAIT_INJ                       16       /* Attesa iniezione */
#define TOPUPSB_NORMAL                       17       /* Settings per inzione MB */
#define TOPUPSB_INJ                       18       /* Iniezione in corso */
#define TOPUPSB_ERR_SCOPE                       19       /* Errore lettura riempimento SCOPE*/
#define TOPUPSB_CURR_HIGH                       20       /* COrrente in SB alta*/
#define TOPUPSB_FILLPAT_COMPARE                       21       /* Single bunch topupsb e fillpat non corrispondenti*/
#define TOPUPSB_MAXCURRENT_ERR            22       /* massima corrente da impostare nel topup*/
#define TOPUPSB_TOO_LONG            23       /* tempo d'iniezione troppo lungo*/
/**
 *	TopupSB class Description:
 *	Topup in single bunch
 */

class fb_thread;

namespace TopupSB_ns
{
	/*----- PROTECTED REGION ID(TopupSB::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations

	/*----- PROTECTED REGION END -----*/	//	TopupSB::Additional Class Declarations


class TopupSB : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(TopupSB::Data Members) ENABLED START -----*/

	//		Add your own data members

	/*----- PROTECTED REGION END -----*/	//	TopupSB::Data Members


//	Device property data members
public:		//	DcctDevice:	Dcct device
	string	dcctDevice;
//	FillpathDevice:	Filpath device
	string	fillpathDevice;
	//	LoopPeriod:	period between each iteration
	Tango::DevLong	loopPeriod;
	//	Min:	minimum threshold
	Tango::DevDouble	min;
	//	Max:	maximum threshold
	Tango::DevDouble	max;
	//	planeGet:	H or V TMBF
	Tango::DevDouble	planeGet;	
	//	GuntimingDevice:	Guntiming device
	string	guntimingDevice;
	//	TopupDevice:	Topup feedback device
	string	topupDevice;
    //  ScopeDevice:    Scope  device
    string  scopeDevice;
	//	NumberTurn:	number of turn to aquire
	Tango::DevDouble	numberTurn;
	//	NumberSb:	number of Sb in hybrid mode
	Tango::DevDouble	numberSb;
	//	Delta:	delta between sb
	Tango::DevDouble	delta;
	//	Plane:	H or V TMBF
	Tango::DevDouble	plane;

//	Attribute data members
public:
	Tango::DevDouble	*attr_SbPosTMBF_read;
	Tango::DevDouble	*attr_SbPtpTMBF_read;
	Tango::DevDouble	*attr_SbPosFillpath_read;
	Tango::DevDouble	*attr_NumberTurn_read;
	Tango::DevDouble	*attr_NumberSb_read;
	Tango::DevDouble	*attr_Delta_read;
	Tango::DevDouble	*attr_Plane_read;
	Tango::DevLong	*attr_ProgrammeBucket_read;
    Tango::DevDouble  *attr_PatternScope_read;
	Tango::DevBoolean	*attr_Progress_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	TopupSB(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	TopupSB(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	TopupSB(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~TopupSB() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : TopupSB::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	SbPosTMBF attribute related methods.
	 *	Description: single bunch position from TMBF
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_SbPosTMBF(Tango::Attribute &attr);
	virtual void write_SbPosTMBF(Tango::WAttribute &attr);
	virtual bool is_SbPosTMBF_allowed(Tango::AttReqType type);



	/**
	 *	SbPtpTMBF attribute related methods.
	 *	Description: single bunch ptp from TMBF
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_SbPtpTMBF(Tango::Attribute &attr);
	virtual bool is_SbPtpTMBF_allowed(Tango::AttReqType type);



	/**
	 *	SbPosFillpath attribute related methods.
	 *	Description: single bunch position from Fillpath
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_SbPosFillpath(Tango::Attribute &attr);
	virtual void write_SbPosFillpath(Tango::WAttribute &attr);
	virtual bool is_SbPosFillpath_allowed(Tango::AttReqType type);



	/**
	 *	NumberTurn attribute related methods.
	 *	Description: number of turn to aquire
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_NumberTurn(Tango::Attribute &attr);
	virtual void write_NumberTurn(Tango::WAttribute &attr);
	virtual bool is_NumberTurn_allowed(Tango::AttReqType type);



	/**
	 *	NumberSb attribute related methods.
	 *	Description: number of turn to aquire
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_NumberSb(Tango::Attribute &attr);
	virtual void write_NumberSb(Tango::WAttribute &attr);
	virtual bool is_NumberSb_allowed(Tango::AttReqType type);



	/**
	 *	Delta attribute related methods.
	 *	Description: number of turn to aquire
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Delta(Tango::Attribute &attr);
	virtual void write_Delta(Tango::WAttribute &attr);
	virtual bool is_Delta_allowed(Tango::AttReqType type);



	/**
	 *	Plane attribute related methods.
	 *	Description: H or V TMBF
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Plane(Tango::Attribute &attr);
	virtual void write_Plane(Tango::WAttribute &attr);
	virtual bool is_Plane_allowed(Tango::AttReqType type);



	/**
	 *	ProgrammeBucket attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Spectrum  max = 432
	 */
	virtual void read_ProgrammeBucket(Tango::Attribute &attr);
	virtual bool is_ProgrammeBucket_allowed(Tango::AttReqType type);



	/**
	 *	Progress attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Spectrum  max = 5
	 */
	virtual void read_Progress(Tango::Attribute &attr);
	virtual bool is_Progress_allowed(Tango::AttReqType type);

    /**
     *  PatternScope attribute related methods.
     *  Description: 
     *
     *  Data type:  Tango::DevLong
     *  Attr type:  Spectrum  max = 432
     */
    virtual void read_PatternScope(Tango::Attribute &attr);
    virtual bool is_PatternScope_allowed(Tango::AttReqType type);




	/**
	 *	Method      : TopupSB::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
		void add_dynamic_attributes();

//	Command related methods
public: 

	bool abortflag;
	bool stopflag;
	bool fb_on;
	void set_devstat(void);
	void abort_sleep(double time);
	double rf_write(double rf_new), fillpathSB,ptpTMBF,posTMBF,numTurn;
	double planeTMBF;
	long pattern[432];
    double patternScope[50000000];
	bool progresso[5];
	bool topupsb_stat[TOPUPSB_STAT_SIZE];
	void MultibunchOn();
	void MultibunchOff();
	void AutomodeOn();
	void AutomodeOff();
     void TopupOff();     
	void LoopmodeOn();
	void LoopmodeOff();
	void KeepboosterOn();
	void KeepboosterOff();
	void EnablesbOn();
	void EnablesbOff();
	int MaxGrid(double mode);
	int MinGrid(double mode);
    int MaxCurrent(double mode);
	int topupState();
	void fillpath_pauseOn();
	void fillpath_pauseOff();
	void fillpath_stop();
	void fillpath_start();
	void fillpath_reset();  
    
	fb_thread *fb_loop;
	Tango::DeviceProxy *DcctD;	
	Tango::DeviceProxy *FillpathD;
	Tango::DeviceProxy *GuntimingD;
	Tango::DeviceProxy *TopupD;
    Tango::DeviceProxy *ScopeD;

	long sid_th, sid_tv;
	vector <double> val_gbun;

	/**
	 *	Command On related methods.
	 */
	void on();
	virtual bool is_On_allowed(const CORBA::Any &any);

	/**
	 *	Command Off related methods.
	 */
	void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);

	/**
	 *	Command Reset related methods.
	 */
	void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);

	/**
	 *	Command Standby related methods.
	 */
	void standby();
	virtual bool is_Standby_allowed(const CORBA::Any &any);



	/*----- PROTECTED REGION ID(TopupSB::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes

	/*----- PROTECTED REGION END -----*/	//	TopupSB::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(TopupSB::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	TopupSB::Additional Classes Definitions

} //	namespace

#endif	//	TOPUPSB_H
