/*----- PROTECTED REGION ID(TopupSBClass.cpp) ENABLED START -----*/

//=============================================================================
//
// file :        TopupSBClass.cpp
//
// description : C++ source for the TopupSBClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the �name� once per process.
//
// project :     TopupSB.
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <TopupSBClass.h>

/*----- PROTECTED REGION END -----*/

//-------------------------------------------------------------------
/**
 *	Create TopupSBClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_TopupSB_class(const char *name) {
		return TopupSB_ns::TopupSBClass::init(name);
	}
}


namespace TopupSB_ns
{


//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
TopupSBClass *TopupSBClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		TopupSBClass::TopupSBClass(string &s)
 * description : 	constructor for the TopupSBClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
TopupSBClass::TopupSBClass(string &s):DeviceClass(s)
{
	cout2 << "Entering TopupSBClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(TopupSBClass::constructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::constructor

	cout2 << "Leaving TopupSBClass constructor" << endl;
}


//--------------------------------------------------------
/**
 * method : 		TopupSBClass::~TopupSBClass()
 * description : 	destructor for the TopupSBClass
 */
//--------------------------------------------------------
TopupSBClass::~TopupSBClass()
{
	/*----- PROTECTED REGION ID(TopupSBClass::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		TopupSBClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
TopupSBClass *TopupSBClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new TopupSBClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		TopupSBClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
TopupSBClass *TopupSBClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}




//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "OnClass::execute(): arrived" << endl;

	
	((static_cast<TopupSB *>(device))->on());
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "OffClass::execute(): arrived" << endl;

	
	((static_cast<TopupSB *>(device))->off());
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "ResetClass::execute(): arrived" << endl;

	
	((static_cast<TopupSB *>(device))->reset());
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		StandbyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StandbyClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "StandbyClass::execute(): arrived" << endl;

	
	((static_cast<TopupSB *>(device))->standby());
	return new CORBA::Any();
}




//===================================================================
//	Properties management
//===================================================================

//--------------------------------------------------------
/**
 * method : 		TopupSBClass::get_class_property
 * description : 	Get the class property for specified name.
 *
 * @param	name  The property name
 */
//--------------------------------------------------------
Tango::DbDatum TopupSBClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::get_default_device_property()()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum TopupSBClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::get_default_class_property()()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum TopupSBClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::get_class_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void TopupSBClass::get_class_property()
{
}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *	              For each property, add to wizard property name and description.
 *	              If default value has been set, add it to wizard property and.
 *	              store it in a DbDatum.
 */
//--------------------------------------------------------
void TopupSBClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;
	
	//	Set Default Class Properties

	//	Set Default Device Properties

	prop_name = "FillpathDevice";
	prop_desc = "Filpath device";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "LoopPeriod";
	prop_desc = "period between each iteration";
	prop_def  = "600\n";
	vect_data.clear();
	vect_data.push_back("600");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Min";
	prop_desc = "minimum threshold";
	prop_def  = "120\n";
	vect_data.clear();
	vect_data.push_back("120");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Max";
	prop_desc = "maximum threshold";
	prop_def  = "210\n";
	vect_data.clear();
	vect_data.push_back("210");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
		
	prop_name = "PlaneGet";
	prop_desc = "H or V TMBF";
	prop_def  = "1\n";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);		

	prop_name = "GuntimingDevice";
	prop_desc = "Guntiming device";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "TopupDevice";
	prop_desc = "Topup feedback device";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "NumberTurn";
	prop_desc = "number of turn to aquire";
	prop_def  = "10000\n";
	vect_data.clear();
	vect_data.push_back("10000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "NumberSb";
	prop_desc = "number of SB in the dark";
	prop_def  = "1\n";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Delta";
	prop_desc = "delta between sb";
	prop_def  = "1\n";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void TopupSBClass::write_class_property()
{
}




//===================================================================
//	Factory methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		TopupSBClass::device_factory
 * description : 	Create the device object(s)
 *                  and store them in the device list
 *
 * @param	*devlist_ptr	The device name list
 */
//--------------------------------------------------------
void TopupSBClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	/*----- PROTECTED REGION ID(TopupSBClass::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new TopupSB(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		TopupSB *dev = static_cast<TopupSB *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(TopupSBClass::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::device_factory_after

	
}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *	              and store them in the attribute list
 */
//--------------------------------------------------------
void TopupSBClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(TopupSBClass::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::attribute_factory_before


	//	Attribute : SbPosTMBF
	SbPosTMBFAttrib	*sbpostmbf = new SbPosTMBFAttrib();
	Tango::UserDefaultAttrProp	sbpostmbf_prop;
	sbpostmbf_prop.set_description("single bunch position from TMBF");
	//	label	not set for	SbPosTMBF
	//	unit	not set for	SbPosTMBF
	//	standard_unit	not set for	SbPosTMBF
	//	display_unit	not set for	SbPosTMBF
	//	format	not set for	SbPosTMBF
	//	max_value	not set for	SbPosTMBF
	//	min_value	not set for	SbPosTMBF
	//	max_alarm	not set for	SbPosTMBF
	//	min_alarm	not set for	SbPosTMBF
	//	max_warning	not set for	SbPosTMBF
	//	min_warning	not set for	SbPosTMBF
	//	delta_t	not set for	SbPosTMBF
	//	delta_val	not set for	SbPosTMBF
	sbpostmbf->set_default_properties(sbpostmbf_prop);
	//	Not Polled
	sbpostmbf->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	SbPosTMBF does not fire change event
	//	SbPosTMBF does not fire archive event
	//	SbPosTMBF does not fire data_ready event
	att_list.push_back(sbpostmbf);

	//	Attribute : SbPtpTMBF
	SbPtpTMBFAttrib	*sbptptmbf = new SbPtpTMBFAttrib();
	Tango::UserDefaultAttrProp	sbptptmbf_prop;
	sbptptmbf_prop.set_description("single bunch ptp from TMBF");
	//	label	not set for	SbPtpTMBF
	//	unit	not set for	SbPtpTMBF
	//	standard_unit	not set for	SbPtpTMBF
	//	display_unit	not set for	SbPtpTMBF
	//	format	not set for	SbPtpTMBF
	//	max_value	not set for	SbPtpTMBF
	//	min_value	not set for	SbPtpTMBF
	//	max_alarm	not set for	SbPtpTMBF
	//	min_alarm	not set for	SbPtpTMBF
	//	max_warning	not set for	SbPtpTMBF
	//	min_warning	not set for	SbPtpTMBF
	//	delta_t	not set for	SbPtpTMBF
	//	delta_val	not set for	SbPtpTMBF
	sbptptmbf->set_default_properties(sbptptmbf_prop);
	//	Not Polled
	sbptptmbf->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	SbPtpTMBF does not fire change event
	//	SbPtpTMBF does not fire archive event
	//	SbPtpTMBF does not fire data_ready event
	att_list.push_back(sbptptmbf);

	//	Attribute : SbPosFillpath
	SbPosFillpathAttrib	*sbposfillpath = new SbPosFillpathAttrib();
	Tango::UserDefaultAttrProp	sbposfillpath_prop;
	sbposfillpath_prop.set_description("single bunch position from Fillpath");
	//	label	not set for	SbPosFillpath
	//	unit	not set for	SbPosFillpath
	//	standard_unit	not set for	SbPosFillpath
	//	display_unit	not set for	SbPosFillpath
	//	format	not set for	SbPosFillpath
	//	max_value	not set for	SbPosFillpath
	//	min_value	not set for	SbPosFillpath
	//	max_alarm	not set for	SbPosFillpath
	//	min_alarm	not set for	SbPosFillpath
	//	max_warning	not set for	SbPosFillpath
	//	min_warning	not set for	SbPosFillpath
	//	delta_t	not set for	SbPosFillpath
	//	delta_val	not set for	SbPosFillpath
	sbposfillpath->set_default_properties(sbposfillpath_prop);
	//	Not Polled
	sbposfillpath->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	SbPosFillpath does not fire change event
	//	SbPosFillpath does not fire archive event
	//	SbPosFillpath does not fire data_ready event
	att_list.push_back(sbposfillpath);

	//	Attribute : NumberTurn
	NumberTurnAttrib	*numberturn = new NumberTurnAttrib();
	Tango::UserDefaultAttrProp	numberturn_prop;
	numberturn_prop.set_description("number of turn to aquire");
	//	label	not set for	NumberTurn
	//	unit	not set for	NumberTurn
	//	standard_unit	not set for	NumberTurn
	//	display_unit	not set for	NumberTurn
	//	format	not set for	NumberTurn
	//	max_value	not set for	NumberTurn
	//	min_value	not set for	NumberTurn
	//	max_alarm	not set for	NumberTurn
	//	min_alarm	not set for	NumberTurn
	//	max_warning	not set for	NumberTurn
	//	min_warning	not set for	NumberTurn
	//	delta_t	not set for	NumberTurn
	//	delta_val	not set for	NumberTurn
	numberturn->set_default_properties(numberturn_prop);
	//	Not Polled
	numberturn->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	NumberTurn does not fire change event
	//	NumberTurn does not fire archive event
	//	NumberTurn does not fire data_ready event
	att_list.push_back(numberturn);

	//	Attribute : NumberSb
	NumberSbAttrib	*numbersb = new NumberSbAttrib();
	Tango::UserDefaultAttrProp	numbersb_prop;
	numbersb_prop.set_description("number of sb in the dark");
	//	label	not set for	NumberSb
	//	unit	not set for	NumberSb
	//	standard_unit	not set for	NumberSb
	//	display_unit	not set for	NumberSb
	//	format	not set for	NumberSb
	//	max_value	not set for	NumberSb
	//	min_value	not set for	NumberSb
	//	max_alarm	not set for	NumberSb
	//	min_alarm	not set for	NumberSb
	//	max_warning	not set for	NumberSb
	//	min_warning	not set for	NumberSb
	//	delta_t	not set for	NumberSb
	//	delta_val	not set for	NumberSb
	numbersb->set_default_properties(numbersb_prop);
	//	Not Polled
	numbersb->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	NumberSb does not fire change event
	//	NumberSb does not fire archive event
	//	NumberSb does not fire data_ready event
	att_list.push_back(numbersb);

	//	Attribute : Delta
	DeltaAttrib	*delta = new DeltaAttrib();
	Tango::UserDefaultAttrProp	delta_prop;
	delta_prop.set_description("delta between sb");
	//	label	not set for	Delta
	//	unit	not set for	Delta
	//	standard_unit	not set for	Delta
	//	display_unit	not set for	Delta
	//	format	not set for	Delta
	//	max_value	not set for	Delta
	//	min_value	not set for	Delta
	//	max_alarm	not set for	Delta
	//	min_alarm	not set for	Delta
	//	max_warning	not set for	Delta
	//	min_warning	not set for	Delta
	//	delta_t	not set for	Delta
	//	delta_val	not set for	Delta
	delta->set_default_properties(delta_prop);
	//	Not Polled
	delta->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Delta does not fire change event
	//	Delta does not fire archive event
	//	Delta does not fire data_ready event
	att_list.push_back(delta);
	
	//	Attribute : Plane
	PlaneAttrib	*plane = new PlaneAttrib();
	Tango::UserDefaultAttrProp	plane_prop;
	plane_prop.set_description("H or V TMBF");
	//	label	not set for	Plane
	//	unit	not set for	Plane
	//	standard_unit	not set for	Plane
	//	display_unit	not set for	Plane
	//	format	not set for	Plane
	//	max_value	not set for	Plane
	//	min_value	not set for	Plane
	//	max_alarm	not set for	Plane
	//	min_alarm	not set for	Plane
	//	max_warning	not set for	Plane
	//	min_warning	not set for	Plane
	//	delta_t	not set for	Plane
	//	delta_val	not set for	Plane
	plane->set_default_properties(plane_prop);
	//	Not Polled
	plane->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Plane does not fire change event
	//	Plane does not fire archive event
	//	Plane does not fire data_ready event
	att_list.push_back(plane);

	//	Attribute : ProgrammeBucket
	ProgrammeBucketAttrib	*programmebucket = new ProgrammeBucketAttrib();
	Tango::UserDefaultAttrProp	programmebucket_prop;
	//	description	not set for	ProgrammeBucket
	//	label	not set for	ProgrammeBucket
	//	unit	not set for	ProgrammeBucket
	//	standard_unit	not set for	ProgrammeBucket
	//	display_unit	not set for	ProgrammeBucket
	//	format	not set for	ProgrammeBucket
	//	max_value	not set for	ProgrammeBucket
	//	min_value	not set for	ProgrammeBucket
	//	max_alarm	not set for	ProgrammeBucket
	//	min_alarm	not set for	ProgrammeBucket
	//	max_warning	not set for	ProgrammeBucket
	//	min_warning	not set for	ProgrammeBucket
	//	delta_t	not set for	ProgrammeBucket
	//	delta_val	not set for	ProgrammeBucket
	programmebucket->set_default_properties(programmebucket_prop);
	//	Not Polled
	programmebucket->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	ProgrammeBucket does not fire change event
	//	ProgrammeBucket does not fire archive event
	//	ProgrammeBucket does not fire data_ready event
	att_list.push_back(programmebucket);
	
	//	Attribute : Progress
	ProgressAttrib	*progress = new ProgressAttrib();
	Tango::UserDefaultAttrProp	progress_prop;
	//	description	not set for	Progress
	//	label	not set for	Progress
	//	unit	not set for	Progress
	//	standard_unit	not set for	Progress
	//	display_unit	not set for	Progress
	//	format	not set for	Progress
	//	max_value	not set for	Progress
	//	min_value	not set for	Progress
	//	max_alarm	not set for	Progress
	//	min_alarm	not set for	Progress
	//	max_warning	not set for	Progress
	//	min_warning	not set for	Progress
	//	delta_t	not set for	Progress
	//	delta_val	not set for	Progress
	progress->set_default_properties(progress_prop);
	//	Not Polled
	progress->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Progress does not fire change event
	//	Progress does not fire archive event
	//	Progress does not fire data_ready event
	att_list.push_back(progress);
    
    //  Attribute : PatternScope
    PatternScopeAttrib   *patternscope = new PatternScopeAttrib();
    Tango::UserDefaultAttrProp  patternscope_prop;
    //  description not set for PatternScopeAttrib
    //  label   not set for PatternScopeAttrib
    //  unit    not set for PatternScopeAttrib
    //  standard_unit   not set for PatternScopeAttrib
    //  display_unit    not set for PatternScopeAttrib
    //  format  not set for PatternScopeAttrib
    //  max_value   not set for PatternScopeAttrib
    //  min_value   not set for PatternScopeAttrib
    //  max_alarm   not set for PatternScopeAttrib
    //  min_alarm   not set for PatternScopeAttrib
    //  max_warning not set for PatternScopeAttrib
    //  min_warning not set for PatternScopeAttrib
    //  delta_t not set for PatternScopeAttrib
    //  delta_val   not set for PatternScopeAttrib
    patternscope->set_default_properties(patternscope_prop);
    //  Not Polled
    patternscope->set_disp_level(Tango::OPERATOR);
    //  Not memorized

    //  PatternScope does not fire change event
    //  PatternScope does not fire archive event
    //  PatternScope does not fire data_ready event
    att_list.push_back(patternscope);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());

	/*----- PROTECTED REGION ID(TopupSBClass::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::attribute_factory_after

}


//--------------------------------------------------------
/**
 *	Method      : TopupSB::TopupSBClass::command_factory()
 *	Description : Create the command object(s)
 *	              and store them in the command list
 */
//--------------------------------------------------------
void TopupSBClass::command_factory()
{
	/*----- PROTECTED REGION ID(TopupSBClass::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::command_factory_before

	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);
	StandbyClass	*pStandbyCmd =
		new StandbyClass("Standby",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStandbyCmd);

	/*----- PROTECTED REGION ID(TopupSBClass::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::command_factory_after

}




//===================================================================
//	Dynamic attributes related methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		TopupSBClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void TopupSBClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;


	/*----- PROTECTED REGION ID(TopupSBClass::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::create_static_att_list

}


//--------------------------------------------------------
/**
 * method : 		TopupSBClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void TopupSBClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		TopupSB *dev = static_cast<TopupSB *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()],true);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(TopupSBClass::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::erase_dynamic_attributes

}



	/*----- PROTECTED REGION ID(TopupSBClass::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TopupSBClass::Additional Methods

} //	namespace
