#include "fb_thread.h"
#include <math.h>
#include <vector>
#include <iostream>

//+------------------------------------------------------------------
//
//	method:			fb_thread::fb_thread()
//
//	description:	fb_thread constructor
//
//-------------------------------------------------------------------
fb_thread::fb_thread(TopupSB_ns::TopupSB *s):Tango::LogAdapter(s)
{ 
	DEBUG_STREAM << "fb_thread::fb_thread(): constructor... !" << endl;
	myfb = s;
	
}

//+------------------------------------------------------------------
//
//	method:			fb_thread::~fb_thread()
//
//	description:	fb_thread destructor
//
//-------------------------------------------------------------------
fb_thread::~fb_thread()
{
	DEBUG_STREAM << "fb_thread::~fb_thread(): destructor... !" << endl;

	//mysilverpak->loopterminatedflag = 1;
	DEBUG_STREAM << "fb_thread::~fb_thread(): deleted... !" << endl;
}

//+------------------------------------------------------------------
//
//	method:			fb_thread::run()
//
//	description:	Run
//
//-------------------------------------------------------------------
void fb_thread::run(void *) 
{
      INFO_STREAM << "fb_thread::run(): running... !" << endl;	
      struct timeval tv_start_th, tv_end_th, tv_start_loop, tv_end_loop, timenow;
      double sr_current,max_grid,min_grid,now_grid,max_current;
      double pick;
      int topup_state;
      unsigned int sb,nsb,delta;
      long timeToInj=0;
      sb = 0;
      nsb=1;
      Tango::DeviceData DD;
      vector<long> fill;
      vector<double> ptpScope; 
      ptpScope.assign(6,0); 
      vector<double> patternScope; 
      patternScope.assign(40000,0);      
      vector<double> patternScope1; 
      patternScope1.assign(40000,0);

      //cout << "0 - myvectorSB.size(): " << myvectorSB.size() << endl;
      vector<long> myvectorSB; 
      myvectorSB.assign(432,0);   
      
      myfb->topupsb_stat[TOPUPSB_DCCT_ERR] = false;	
      myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = false;
      myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
      myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
      myfb->topupsb_stat[TOPUPSB_THREAD_ERR_THRESHOLD] = false;	
      myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = false;
      myfb->topupsb_stat[TOPUPSB_GRID_ERR] = false;
      myfb->topupsb_stat[TOPUPSB_MAXCURRENT_ERR] = false;
      myfb->topupsb_stat[TOPUPSB_TOPUP_ERR] = false;
      myfb->topupsb_stat[TOPUPSB_GUNTIMING_ERR] = false;
      myfb->topupsb_stat[TOPUPSB_SB_SET] = false;
      myfb->topupsb_stat[TOPUPSB_WAIT] = false;
      myfb->topupsb_stat[TOPUPSB_WAIT_MAX] = false;
      myfb->topupsb_stat[TOPUPSB_INJ] = false;
      myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
      myfb->topupsb_stat[TOPUPSB_CURR_HIGH] = false;
      myfb->topupsb_stat[TOPUPSB_FILLPAT_COMPARE] = false;
		myfb->topupsb_stat[TOPUPSB_TOO_LONG] = false;
      
      
      printf("Out Loop: Massimo picco accettabile %f\n",myfb->max);

	while (myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY])
	{	
        try {
            ptpScope.assign(6,0);
            myfb->ScopeD->read_attribute("vpp") >> ptpScope;
            myfb->ptpTMBF = ptpScope[0]*2*myfb->numberSb;
            printf("Standby loop: piccopicco %f\n",myfb->ptpTMBF);
            myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
            myfb->abort_sleep(2);
        }
        catch(Tango::DevFailed &e) { 
            myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = true;
            myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
            myfb->abortflag = true;
        }
	
		sb = myfb->fillpathSB;
		if (sb == 0) {
			myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                           myfb->topupsb_stat[TOPUPSB_SB_SET] = true;
			printf("Nessun buchet settato a 1\n");
			myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
			myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
			myfb->abortflag = true;
		}
		else myfb->progresso[0] = 1;
		
			
		gettimeofday(&tv_start_th,NULL);
          gettimeofday(&timenow,NULL);        
		/************** read dcct **************/
		try {
			myfb->DcctD->read_attribute("Current") >> sr_current;
			myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = false;
		}
		catch(Tango::DevFailed &e) { 
			myfb->topupsb_stat[TOPUPSB_DCCT_ERR] = true;
			myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
		}	
		if (sr_current < 20) {
			myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
			myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = true;
		}
		else {
			myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = false;
			printf("Standby loop: current %f\n",sr_current);	
		}
		/************************* if feedback is ON *************************/	
		if (myfb->topupsb_stat[TOPUPSB_THREAD_ON] && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR])) ){
			printf("ON loop\n");		

            try {
                  ptpScope.assign(6,0);
                  myfb->ScopeD->read_attribute("vpp") >> ptpScope;
                  myfb->ptpTMBF = ptpScope[0]*2*myfb->numberSb;
                  printf("ON: piccopicco %f\n",myfb->ptpTMBF);
                  myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
                  myfb->abort_sleep(2);
            }
            catch(Tango::DevFailed &e) { 
                  myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = true;
                  myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                  myfb->abortflag = true;
            }
            pick = myfb->ptpTMBF ;
			myfb->abortflag = false;
			gettimeofday(&tv_end_loop,NULL);		
			

			/************** if feedback is ON **************/			
			while (myfb->topupsb_stat[TOPUPSB_THREAD_ON] && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR])) ) {
				
				gettimeofday(&tv_start_loop,NULL);

				/************** read dcct **************/
				try {
					myfb->DcctD->read_attribute("Current") >> sr_current;
					myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = false;
					myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
				}
				catch(Tango::DevFailed &e) { 
					myfb->topupsb_stat[TOPUPSB_DCCT_ERR] = true;
					myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
					myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
				}	
				if (sr_current < 20) {
					myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
					myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = true;
					myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
				}
				else {
					myfb->topupsb_stat[TOPUPSB_DCCT_CURR] = false;
					myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
				}

				  try {
                        ptpScope.assign(6,0);
                        myfb->ScopeD->read_attribute("vpp") >> ptpScope;
                        myfb->ptpTMBF = ptpScope[0]*2*myfb->numberSb;
                        printf("ON: piccopicco %f\n",myfb->ptpTMBF);
                        myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
                        myfb->abort_sleep(2);
                  }
                  catch(Tango::DevFailed &e) { 
                        myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = true;
                        myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                        myfb->abortflag = true;
                  }
                  pick = myfb->ptpTMBF ;
                  myfb->abortflag = false;	
						if (pick>myfb->max){                               //if aggiuntivo per resettare lo stato di alarm per superamento di soglia massima del SB
							myfb->topupsb_stat[TOPUPSB_CURR_HIGH] = false;
						}
						printf("On Loop: PtP %f\n",pick);
                    if (pick < myfb->min){
                         myfb->abort_sleep(5);
                        try {
                              ptpScope.assign(6,0);
                              myfb->ScopeD->read_attribute("vpp") >> ptpScope;
                              myfb->ptpTMBF = ptpScope[0]*2*myfb->numberSb;
                              printf("Picco inferiore: piccopicco %f\n",myfb->ptpTMBF);
                              myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
                              myfb->abort_sleep(2);
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->abortflag = true;
                        }
                        pick = myfb->ptpTMBF ;    
                        printf("Secondo controllo Loop: di picco %f\n",pick);
                    }                                 
                    
                 	if ((pick < myfb->min) && (myfb->topupsb_stat[TOPUPSB_THREAD_ON])&& (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
					myfb->TopupD->read_attribute("TimeToGo") >> timeToInj;
                        while (timeToInj<30 && myfb->topupsb_stat[TOPUPSB_THREAD_ON] && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) { 
                              myfb->topupsb_stat[TOPUPSB_WAIT] = true;
                              //printf("On Loop: attesa, prossima inizione troppo vicina%f\n",timeToInj);
                              myfb->abort_sleep(10);
                              myfb->TopupD->read_attribute("TimeToGo") >> timeToInj;
                              myfb->topupsb_stat[TOPUPSB_WAIT] = false;
                        }
                        myfb->topupsb_stat[TOPUPSB_WAIT] = false;
                        myfb->TopupD->read_attribute("TimeToGo") >> timeToInj;
                        while (timeToInj>50 && myfb->topupsb_stat[TOPUPSB_THREAD_ON] && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) { 
                              myfb->topupsb_stat[TOPUPSB_WAIT_MAX] = true;
                              //printf("On Loop: attesa, prossima inizione molto distante %f\n",timeToInj);
                              myfb->abort_sleep(10);
                              myfb->TopupD->read_attribute("TimeToGo") >> timeToInj;
                              myfb->topupsb_stat[TOPUPSB_WAIT_MAX] = false;
                        }
                        myfb->topupsb_stat[TOPUPSB_WAIT_MAX] = false;  
                                                                       
                        printf("On Loop: attivazione loop iniezione SB\n");                        
                        myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = true;                   
                        
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                                    myfb->TopupD->read_attribute("CurrentMax") >> max_current;
                              }
                              catch(Tango::DevFailed &e) { 
                                    myfb->topupsb_stat[TOPUPSB_MAXCURRENT_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              } 
                        }                        
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                                    myfb->TopupD->read_attribute("MaxGridVoltage") >> max_grid;
                              }
                              catch(Tango::DevFailed &e) { 
                                    myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }	
                        }
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                                    myfb->TopupD->read_attribute("MinGridVoltage") >> min_grid;
                              }
                              catch(Tango::DevFailed &e) { 
                                    myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                        }
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                                    myfb->TopupD->read_attribute("GridVoltage") >> now_grid;
                              }
                              catch(Tango::DevFailed &e) { 
                                    myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                        }
                        printf("On Loop: MaxGrid\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                                    myfb->MaxGrid(now_grid+0.1);
                              }
                              catch(Tango::DevFailed &e) { 
                                    myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                        }
                        printf("On Loop: MinGrid\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                                    myfb->MinGrid(now_grid-0.1);
                              }
                              catch(Tango::DevFailed &e) { 
                                    myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                    myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                        }
                        
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) myfb->progresso[1] = 1;
                        
                        printf("On Loop: Multibunch\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->MultibunchOff();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_GUNTIMING_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(2);
                        }
                        
                        myfb->progresso[2] = 1;
                        
                        printf("On Loop: fillpath_pause\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->fillpath_pauseOff();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(2);
                        }
                        printf("On Loop: fillpath_stop\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->fillpath_stop();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(2);
                        }
                        printf("On Loop: Automode\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->AutomodeOff();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(2);
                        }
                        printf("On Loop: Loopmode\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->LoopmodeOn();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(2);
                        }
                  
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->fillpath_reset();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(1);
                        }
                        printf("On Loop: Program Fillpath\n");
                        myfb->abort_sleep(4);

								long int nsb=myfb->numberSb;
								switch (nsb){
									case 0:
									fill.assign(2,0);
									fill[0]=1;
									fill[1]=sb;
									break;
						
									case  1:
									fill.assign(2,0);
									fill[0]=1;
									fill[1]=sb;
									break;
						
									case  2:
									fill.assign(3,0);
									delta = myfb->delta;
									fill[0]=1;
									fill[1]=sb-round(delta/4);
									fill[2]=sb+round(delta/4);
									break;
						
									case  3:
									fill.assign(4,0);
									delta = myfb->delta;
									fill[0]=1;
									fill[1]=sb+round(delta/2);
									fill[2]=sb;
									fill[3]=sb+round(delta/2);
									break;
						
								default:
									fill.assign(2,0);
									fill[0]=1;
									fill[1]=sb;
								}
// 								printf("0 %i\n",fill[0]);
// 								printf("1 %i\n",fill[1]);
// 								printf("2 %i\n",fill[2]);
// 								printf("3 %i\n",fill[3]);
								DD << fill;	
								myfb->FillpathD->command_inout("Program",DD);
								fill.clear();
                        
                        printf("On Loop: fillpath_start\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->fillpath_start();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(1);
                        }
                        
                        myfb->progresso[3] = 1;
                        
                        printf("On Loop: Keepbooster e enablesb\n");
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->KeepboosterOn();
										try {
												myfb->TopupD->command_inout("Off");
										}
										catch(Tango::DevFailed &e) { 
										}
                              myfb->abort_sleep(1);
										myfb->EnablesbOn();
										try {
												myfb->TopupD->command_inout("On");
										}
										catch(Tango::DevFailed &e) { 
										}
                              myfb->abort_sleep(1);
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_TOPUP_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(1);
                        }
                        
                        myfb->progresso[4] = 1;
                        myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        myfb->topupsb_stat[TOPUPSB_WAIT_INJ] = true;	
                              
                        topup_state = myfb->topupState();
                        printf("On Loop: TopupState %i\n",topup_state);
                        
                        while ((topup_state == 0)&&(myfb->topupsb_stat[TOPUPSB_THREAD_ON]&& (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR])))) {
                              printf("On Loop: Waiting for topup injection");
                              
                              myfb->abort_sleep(2);
                              topup_state = myfb->topupState();
                              printf("-------- TopupState %i\n",topup_state);
                        }
                        
                        printf("On Loop: Injection preparation\n");
                        topup_state = myfb->topupState();
                        printf("-------- TopupState %i\n",topup_state);
                        myfb->topupsb_stat[TOPUPSB_WAIT_INJ] = false;
                        int countSB=0;
                        int SBstate=1;
                        myfb->topupsb_stat[TOPUPSB_CURR_HIGH] = false;
                        while ((topup_state != 0)&&(SBstate==1)&&(myfb->topupsb_stat[TOPUPSB_THREAD_ON])&& (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              
                                    myfb->topupsb_stat[TOPUPSB_INJ] = true;
                                    printf("On Loop: Injection On\n");
                                    
                                    
                                    printf("On Loop: Change topup max current to -0.2mA\n");
                                    try {
                                          myfb->MaxCurrent(max_current-0.2);
                                    }
                                    catch(Tango::DevFailed &e) { 
                                          myfb->topupsb_stat[TOPUPSB_MAXCURRENT_ERR] = true;
                                          myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                          myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                                          myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                                          myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                                    }
                                    
                                    try {
                                          ptpScope.assign(6,0);
                                          myfb->ScopeD->read_attribute("vpp") >> ptpScope;
                                          myfb->ptpTMBF = ptpScope[0]*2*myfb->numberSb;
                                          printf("Standby loop: piccopicco %f\n",myfb->ptpTMBF);
                                          myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
                                          myfb->abort_sleep(2);
                                    }
                                    catch(Tango::DevFailed &e) { 
                                          myfb->topupsb_stat[TOPUPSB_TOPUP_ERR] = true;
                                          myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = true;
                                          myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                                          myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                                    }
                                    pick = myfb->ptpTMBF ;    
                                    printf("SB injection Loop: di picco %f\n",pick); 
                                    
                                    if (pick>myfb->max){
                                          SBstate=0;
                                          printf("SB injection Loop: picco troppo ALTO STOP %f\n",pick);
                                          // myfb->TopupOff();
                                          myfb->topupsb_stat[TOPUPSB_CURR_HIGH] = true;
                                                                 
                                    }     
                                          
                              myfb->abort_sleep(2);
                              topup_state = myfb->topupState();
                              printf("-------- TopupState %i\n",topup_state);                              
                              countSB=countSB+1;
                              printf("Out Loop: countSB= %i\n",countSB);
                              if (countSB>60){
                              	printf(" Iniezione SB troppo lunga \n");
											myfb->TopupOff();
											myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false; 
											myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
											myfb->topupsb_stat[TOPUPSB_TOO_LONG] = true;
                              	
                              }
                              
                              
                        }
                        myfb->topupsb_stat[TOPUPSB_INJ] = false;
                  		
								// scehda carniel
								try {
                              myfb->TopupD->command_inout("Off");
                        }
                        catch(Tango::DevFailed &e) { 
                        }
								// scehda carniel


                        printf("On Loop: Change topup max current to starting value\n");
                        try {
                              myfb->MaxCurrent(max_current);
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_MAXCURRENT_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->topupsb_stat[TOPUPSB_NORMAL] = true;                    
                        printf("On Loop: Keepbooster\n");					
                        try {
                              myfb->KeepboosterOff();
										try {
												myfb->TopupD->command_inout("Off");
										}
										catch(Tango::DevFailed &e) { 
										}
                              myfb->abort_sleep(1);
										myfb->EnablesbOff();
										try {
												myfb->TopupD->command_inout("On");
										}
										catch(Tango::DevFailed &e) { 
										}
                              myfb->abort_sleep(1);
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_TOPUP_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->abort_sleep(1);
                        
                        myfb->progresso[4] = 0;
                        
                        printf("On Loop: Multibunch\n");					
                        try {
                              myfb->MultibunchOn();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_GUNTIMING_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->abort_sleep(2);
                        
                        myfb->progresso[2] = 0;
                        
                        printf("On Loop: fillpath_stop\n");	
                        try {
                              myfb->fillpath_stop();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->abort_sleep(2);
                        
                        printf("On Loop: Automode\n");	
                        try {
                              myfb->AutomodeOn();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->abort_sleep(2);					
                  
                        if ((myfb->topupsb_stat[TOPUPSB_THREAD_ON]) && (!(myfb->topupsb_stat[TOPUPSB_THREAD_ERR]))) {
                              try {
                              myfb->fillpath_reset();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                              }					
                              catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                              }
                              myfb->abort_sleep(1);
                        }
                        
                        printf("On Loop: fillpath_pause\n");
                        try {
                              myfb->fillpath_pauseOff();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->abort_sleep(2);
                        
                        printf("On Loop: fillpath_start\n");
                        try {
                              myfb->fillpath_start();
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = false;
                        }					
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_FILLPATH_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        myfb->abort_sleep(2);
                              
                        myfb->progresso[3] = 0;
                        
                        printf("On Loop: MaxGrid\n");
                        try {
                              myfb->MaxGrid(max_grid);
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        
                        printf("On Loop: MinGrid\n");
                        try {
                              myfb->MinGrid(min_grid);
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_GRID_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ERR] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                        }
                        
                        myfb->progresso[1] = 0;
                        try {
                              ptpScope.assign(6,0);
                              myfb->ScopeD->read_attribute("vpp") >> ptpScope;
                              myfb->ptpTMBF = ptpScope[0]*2*myfb->numberSb;
                              printf("Standby loop: piccopicco %f\n",myfb->ptpTMBF);
                              myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = false;
                              myfb->abort_sleep(2);
                        }
                        catch(Tango::DevFailed &e) { 
                              myfb->topupsb_stat[TOPUPSB_ERR_SCOPE] = true;
                              myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY] = false;
                              myfb->topupsb_stat[TOPUPSB_THREAD_ON] = false;
                              myfb->abortflag = true;
                        }                    
                        pick = myfb->ptpTMBF ;	
                        printf("SB injection Loop: di picco %f\n",pick); // Aggiorno il valore del SB

								// scehda carniel
								
                        myfb->abort_sleep(5);
								try {
                              myfb->TopupD->command_inout("On");
                        }
                        catch(Tango::DevFailed &e) { 
                        }
								// scehda carniel
                  
                  }
                  myfb->topupsb_stat[TOPUPSB_NORMAL] = false;
                  myfb->topupsb_stat[TOPUPSB_THREAD_CORRECTION] = false;
                  if (myfb->topupsb_stat[TOPUPSB_THREAD_ON]){
					gettimeofday(&tv_end_loop,NULL);	
					long s_sleep = myfb->loopPeriod - (tv_end_loop.tv_sec - tv_start_loop.tv_sec);
					
					if (s_sleep > 0) {
                              gettimeofday(&timenow,NULL);
                              printf("%s:", ctime(&(timenow.tv_sec)));                    
						//printf("On loop: sleep long %d sec\n",s_sleep);
						//printf("loopperiod %d sec\n",myfb->loopPeriod);
						
						if (myfb->topupsb_stat[TOPUPSB_THREAD_ON])
							myfb->abort_sleep(s_sleep);
					}
					else {
						myfb->abort_sleep(2);
						printf("On loop: takes too long, no sleep\n");
						}
				}
				myfb->topupsb_stat[TOPUPSB_THREAD_SLEEP] = false;
			}
		}
		gettimeofday(&tv_end_th,NULL);	
		long s_sleep = myfb->loopPeriod - (tv_end_th.tv_sec - tv_start_th.tv_sec);
		if (s_sleep > 0) {
			//printf("Standby loop: sleep long %d sec\n",s_sleep);
			if (myfb->topupsb_stat[TOPUPSB_THREAD_STANDBY])
				myfb->abort_sleep(s_sleep);
		}
		else {
			myfb->abort_sleep(2);
			printf("Standby loop: takes too long, no sleep\n");
		}
	}	
	printf("Exit from the loop\n");	
	myfb->abortflag = false;

}

